.equ SWI_SETSEG8, 0x200 @display on 8 Segment
.equ SWI_SETLED, 0x201 @LEDs on/off
.equ SWI_CheckBlack, 0x202 @check Black button
.equ SWI_CheckBlue, 0x203 @check press Blue button
.equ SWI_DRAW_STRING, 0x204 @display a string on LCD
.equ SWI_DRAW_INT, 0x205 @display an int on LCD
.equ SWI_CLEAR_DISPLAY,0x206 @clear LCD
.equ SWI_DRAW_CHAR, 0x207 @display a char on LCD
.equ SWI_CLEAR_LINE, 0x208 @clear a line on LCD
.equ SWI_EXIT, 0x11 @terminate program
.equ SWI_GetTicks, 0x6d @get current time
.equ SEG_A, 0x80 @ patterns for 8 segment display
.equ SEG_B, 0x40 @byte values for each segment
.equ SEG_C, 0x20 @of the 8 segment display
.equ SEG_D, 0x08
.equ SEG_E, 0x04
.equ SEG_F, 0x02
.equ SEG_G, 0x01
.equ SEG_P, 0x10
.equ LEFT_LED, 0x02 @bit patterns for LED lights
.equ RIGHT_LED, 0x01
.equ LEFT_BLACK_BUTTON,0x02 @bit patterns for black buttons
.equ RIGHT_BLACK_BUTTON,0x01 @and for blue buttons
.equ BLUE_KEY_00, 0x01 @button(0)
.equ BLUE_KEY_01, 0x02 @button(1)
.equ BLUE_KEY_02, 0x04 @button(2)
.equ BLUE_KEY_03, 0x08 @button(3)
.equ BLUE_KEY_04, 0x10 @button(4)
.equ BLUE_KEY_05, 0x20 @button(5)
.equ BLUE_KEY_06, 0x40 @button(6)
.equ BLUE_KEY_07, 0x80 @button(7)
.equ BLUE_KEY_08, 1<<8 @button(8) - different way to set
.equ BLUE_KEY_09, 1<<9 @button(9)
.equ BLUE_KEY_10, 1<<10 @button(10)
.equ BLUE_KEY_11, 1<<11 @button(11)
.equ BLUE_KEY_12, 1<<12 @button(12)
.equ BLUE_KEY_13, 1<<13 @button(13)
.equ BLUE_KEY_14, 1<<14 @button(14)
.equ BLUE_KEY_15, 1<<15 @button(15)

.equ Sec1, 1000 @ 1 seconds interval
.equ Point1Sec, 100 @ 0.1 seconds interval
.equ EmbestTimerMask, 0x7fff @ 15 bit mask for timer values
.equ Top15bitRange, 0x0000ffff @(2^15) -1 = 32,767
.text
_start:
mov r6,#0 @ counting the loops (not necessary)
ldr r8,=Top15bitRange
ldr r7,=EmbestTimerMask
ldr r10,=Point1Sec
SWI SWI_GetTicks @Get current time T1
mov r1,r0 @ R1 is T1
and r1,r1,r7 @ T1 in 15 bits
RepeatTillTime:
add r6,r6,#1 @ count number of loops (not necessary)
SWI SWI_GetTicks @Get current time T2
mov r2,r0 @ R2 is T2
and r2,r2,r7 @ T2 in 15 bits
cmp r2,r1 @ is T2>T1?
bge simpletime
sub r9,r8,r1 @ TIME= 32,676 - T1
add r9,r9,r2 @ + T2
bal CheckInt
simpletime:
sub r9,r2,r1 @ TIME = T2-T1
CheckInt:
cmp r9,r10 @is TIME < interval?
blt RepeatTillTime
swi SWI_EXIT
.end