@@@ OPEN TWO INPUT FILES, READ INTEGERS FROM FILE, STORE INTEGERS TO MEMORY, CLOSE INPUT FILES
.equ SWI_Open, 0x66 @open a file
.equ SWI_Close,0x68 @close a file
.equ SWI_PrChr,0x00 @ Write an ASCII char to Stdout
.equ SWI_PrStr, 0x69 @ Write a null-ending string
.equ SWI_PrInt,0x6b @ Write an Integer
.equ SWI_RdInt,0x6c @ Read an Integer from a file
.equ Stdout, 1 @ Set output target to be Stdout
.equ SWI_Exit, 0x11 @ Stop execution
.global _start
.text
_start:
@
@ == Open two input files for reading =============================
@ if problems, print message to Stdout and exit
ldr r0,=InFile1Name @ set Name for input file
mov r1,#0 @ mode is input
swi SWI_Open @ open file for input
bcs InFileError @ Check Carry-Bit (C): if= 1 then ERROR
@ Save the file handle in memory:
ldr r1,=InFile1Handle @ if OK, load input file handle
str r0,[r1] @ save the file handle
@
ldr r0,=InFile2Name @ set Name for input file
mov r1,#0 @ mode is input
swi SWI_Open @ open file for input
bcs InFileError @ Check Carry-Bit (C): if= 1 then ERROR
@ Save the file handle in memory:
ldr r1,=InFile2Handle @ if OK, load input file handle
str r0,[r1] @ save the file handle
@ == Read integers until end of file 1 and store to memory =====
ldr r1,=Array1 @load address of array1
RLoop1:
ldr r0,=InFile1Handle @ load input file handle
ldr r0,[r0]
swi SWI_RdInt @ read the integer into R0
bcs EofReached1 @ Check Carry-Bit (C): if= 1 then EOF reached
str r0,[r1]
add r1,r1,#4
bal RLoop1 @ keep reading till end of file
@ == End of file 1 ==============================================
EofReached1:
mov R0, #Stdout @ print last message
ldr R1, =EndOfFileMsg
swi SWI_PrStr
@ == Close file 1 ================================================
ldr R0, =InFile1Handle @ get address of file handle
ldr R0, [R0] @ get value at address
swi SWI_Close
@ == Read integers until end of file 2 and store to memory =======
ldr r1,=Array2 @load address of array2
RLoop2:
ldr r0,=InFile2Handle @ load input file handle
ldr r0,[r0]
swi SWI_RdInt @ read the integer into R0
bcs EofReached2 @ Check Carry-Bit (C): if= 1 then EOF reached
str r0,[r1]
add r1,r1,#4
bal RLoop2 @ keep reading till end of file
@ == End of file 2 ==============================================
EofReached2:
mov R0, #Stdout @ print last message
ldr R1, =EndOfFileMsg
swi SWI_PrStr
@ == Close file 2 ===============================================
ldr R0, =InFile2Handle @ get address of file handle
ldr R0, [R0] @ get value at address
swi SWI_Close
Exit:
swi SWI_Exit @ stop executing
InFileError:
mov R0, #Stdout
ldr R1, =FileOpenInpErrMsg
swi SWI_PrStr
bal Exit @ give up, go to end
.data
.align
InFile1Handle: .skip 4
InFile1Name: .asciz "inputfile1.txt"
.align
InFile2Handle: .skip 4
InFile2Name: .asciz "inputfile2.txt"
FileOpenInpErrMsg: .asciz "Failed to open input file \n"
EndOfFileMsg: .asciz "End of file reached\n"
.align
Array1: .skip 256  @ Memory address for storing integers of file 1
Array2: .skip 256  @ Memory address for storing integers of file 2
.end